/*     */
    /*
    * ********************************************************************
    * *             Copyright (c) IBM Corporation, 1995                  *
    * *                     All Rights Reserved                          *
    * ********************************************************************
    *
    *
    * DESCRIPTION: This REXX command file is to be used to make changes
    *              to CONFIG.SYS for IBM Microchannel PS/2's in order
    *              to install Microsoft applications that are in DMF
    *              format on your IBM PS/2 Microchannel system.
    *
    */

   /*      trace I */
    call init

    /* Get the version of the current OS/2 system. */
    version = SysOs2Ver()
    if version < '2.30' then  /* 2.30 represents Warp version. */
      do
        say ' ⮩ ᨨ OS/2   䠩  ࠡ⠥.'
        say 'ணࠬ 襭.'
        exit
      end
    "@cls"
    Say ' '
    Say ' '
    Say ' '
    Say ' ணࠬ  짮⥫ OS/2 Warp, ࠡ騬 '
    Say ' IBM PS/2, ⠫஢ ணࠬ ।⢠,'
    Say '⠢塞  ᪥, ⮢  ⠭⭮ ଠ DMF.'
    Say ' '
    Say ' ணࠬ  䠩 CONFIG.SYS, ⮡ ᯥ'
    Say '⥭ ᪥ DMF. ᫥ ⠫樨 ணࠬ । DMF'
    Say '᭮ 믮  ணࠬ, 㪠 ० ,'
    Say '⮡ ⠭ ࢮ砫 䠩 CONFIG.SYS.'
    Say ' '
    Say '⮡  䠩 CONFIG.SYS OS/2 Warp, ᯥ稢騩'
    Say 'প ⠫樨  ᪥ ଠ DMF,  '
    Say ' '
    Say '⮡ ⪠    䠩 CONFIG.SYS OS/2 Warp,'
    Say '易  DMF,  '
    Say ' '
    Say '⮡   ⮩ ணࠬ, 祣  ,  '
    Say ' '
    Say '⢥  (),  (⠭)   (室).'

    parse upper pull answer .   /* Get the answer */

    if (answer='' | answer='') then    /* If answer is exit then exit */
      say '室   䠩!'

    else if (answer='' | answer='') then
      call UNDO    /* If the answer is UNDO then go to the UNDO Subroutine */

    else if (answer='' | answer = '') then
     do           /* If the answer is Modify then modify config.sys */
      '@cls'
      say ' '
      say ' '
      say ' '
      say '  ன⢥ ⠫஢ 樮 ⥬ OS/2 Warp?'
      say ' 㪢 ன⢠   (ਬ, C:\)'
      say ''

        /* Check whether the given drive is valid. */
        call Checkdrive        /* GO to the Checkdrive subroutine */

        fname=drive'\config.sys' /* Assign drive letter and path for config.sys */

        /* Check whether config.sys exists. */
        call sysfiletree fname, 'files.', 'F'

        if files.0 < 1 then
          do
            say ' CONFIG.SYS  .'
            say 'ணࠬ 襭.'
            exit
          end

        sname=drive'\config.dmf'  /* Assign drive letter and path to */
                                  /* config.sys back up file name */

        /* Check whether config.dmf exists. */
        call sysfiletree sname, 'files.', 'F'

        if files.0 >= 1 then
          do
            say ' Config.dmf .    १ (/)?'

            parse upper pull answer
            answer = left(answer,1)
            if answer = '' then
              do
                say '० 祬 ୮ 믮 dmf_ps2,'
                say '२  㤠 䠩 config.dmf.'
                exit
              end
          end

        nname=drive'\config1.tmp'  /* Assign drive letter and path to */
                                   /* temporary file */

        say '믮 .......'
        say ' '
        "@copy" fname sname ">nul 2>nul" /* Backup config.sys */

        call lineout nname,,1
        do while lines(fname)   /* Parse through config.sys looking for */
           str = linein(fname)  /* the string to be modified */
           basedev = (substr(str,1,20))  /* Only need to look at first 20 */
                                         /* characters of the line */
           select
              when substr(basedev,1,20) == 'BASEDEV=IBM1FLPY.ADD' then do
                  if left(reverse(str), 4) \= 'ACM/' then do
                    call lineout nname, str '/MCA'  /* Add /MCA option to */
                    end                             /* IBM1FLPY.ADD driver */
                  else
                    call lineout nname, str
                    end
              when substr(basedev,1,20) == 'BASEDEV=IBM2FLPY.ADD' then do
                    call lineout nname, 'REM' str /* REM out the */
                    end                           /* IBM2FLPY.ADD driver */
              otherwise do
                    call lineout nname, str
                    end
           end
         end

         call lineout fname
         call lineout nname
         "@copy" nname fname ">nul 2>nul"
         "@erase" nname
         "@cls"


         say ''
         say ''
         say ''
         say ''
         say ' 䠩' fname
         say ''
         say ' CONFIG.SYS . ࢮ砫쭠  ⮣ 䠩'
         say '࠭  䠩 CONFIG.DMF.  ⮣, ⮡  㯨'
         say ' ᨫ, ன 樮 ⥬  १㧨 .'
         say ''
         say 'ਫ DMF 㦥 ⠫஢. ⮡ ⠭ ⥬'
         say ' ࢮ砫쭮 ﭨ, ୮ 믮 DMF_PS2'
         say ' ०  (⠭).'

      end
    else
        say '⢥  ᯮ.'
        say 'ணࠬ 襭.'

exit

UNDO:
    '@cls'
    say ' '
    say ' '
    say ' '
    say '  ன⢥ ⠫஢ 樮 ⥬ OS/2 Warp?'
    say ' 㪢 ன⢠   (ਬ, C:\)'
    say ' '

    call Checkdrive

    fname=drive'\config.sys'

    call sysfiletree fname, 'files.', 'F'
    if files.0 < 1 then
      do
        say ' CONFIG.SYS  .'
        say 'ணࠬ 襭.'
        exit
      end

    nname=drive'\config1.tmp'

    do while lines(fname)            /* This section of code is to check the */
      str = linein(fname)            /* config.sys to see if the DMF changes */
      basedev = (substr(str,1,24))   /* need to be UNDone. */
      select
        when substr(basedev,1,20) == 'BASEDEV=IBM2FLPY.ADD' then do
             "@CLS"
             say ' '                  /* If it finds this then display */
             say ' '                  /* Message */
             say ' '
             say ' 䠩 CONFIG.SYS   ⭮⥫쭮 DMF'
             say '⬥ 祣'
             say 'ணࠬ 襭.'
             call exit
             end
        when substr(basedev,1,24) == 'REM BASEDEV=IBM2FLPY.ADD' then do
             call lineout nname
             call lineout fname         /* If it finds this then lets */
             call undo2                 /* call undo2 to really undo the */
             end                        /* DMF changes */
        otherwise do
              call lineout nname, str
              end
    end
  end
EXIT:
    call lineout nname
    "@ERASE" nname
    exit

UNDO2:

   "@erase" nname

    nname=drive'\config1.tmp'

    call lineout nname,,1
    do while lines(fname)
      str = linein(fname)
      basedev = (substr(str,1,24))

      select
        when substr(basedev,1,24) == 'REM BASEDEV=IBM2FLPY.ADD' then do
              newstr = (subword(str,2))
              call lineout nname, newstr
              end
        when substr(basedev,1,20) == 'BASEDEV=IBM1FLPY.ADD' then do
              parse var str final remaining
              num_item = words(remaining)
              do p = 1 to num_item
                if strip(word(remaining, p)) \= '/MCA' then
                  final = final || ' 'word(remaining, p)
              end
              call lineout nname, final
              end
        otherwise do
              call lineout nname, str
              end
      end
    end
    call lineout fname
    call lineout nname
    "@copy" nname fname ">nul 2>nul"
    "@erase" nname
    "@cls"


    say ''
    say ''
    say ''
    say ''
    say ' CONFIG.SYS ⠭.  ⮣, ⮡  㯨'
    say ' ᨫ, ன 樮 ⥬  १㧨 .'
    say ''
exit

CheckDrive:
    /* Get all the local drive letters. */
    drivemap = sysdrivemap('c:', 'LOCAL')

    parse upper pull drive .

    drive = strip(translate(drive, ' ', '\'))
    num_item = words(drive)
    if num_item > 1 then
      do
        say 'ன⢮  ᯮ.'
        say 'ணࠬ 襭.'
        exit
      end
    found = 'NO'
    do while drivemap \= ''
      parse var drivemap head tail
      drivemap = tail
      head = strip(head)
      if head = drive then
         found = 'YES'
    end

    if found = 'NO' then
      do
        say 'ன⢮  ᯮ.'
        say 'ணࠬ 襭.'
      end
return

/* Load in the extra function library. WPW001 */
Init: Procedure

    /* Load in the extra function library */
    if RxFuncQuery('SysLoadFuncs') then do
        Call RXFuncAdd 'SysLoadFuncs','RexxUtil','SysloadFuncs'
    end
    Call SysLoadFuncs
return
